<?php
	// http://viconsaga.com.br/migration.php?idProject=3&blnTest=1 // PGORH
	echo 'Parmetros: blnClearAll, idProject, blnTest, blnNoRecords <BR>';
	$strViconOldFolder = 'http://www.viconsaga.com.br/2012';
	$intTestMax = 3;
	$blnTest = $_GET['blnTest'] == 1 ? true : false;	
	set_time_limit(3000); // Increasing Timeout to Garantee Enough Time
	session_start();

	// Engine Classes 2014
	include_once 'engine/database.php';
	$database = new Database();
	include_once 'engine/project.php';
	$project = new Project($database);
	include_once 'engine/user.php';
	$user = new User($database);
	include_once 'engine/form.php';
	$form = new Form($database);
	include_once 'engine/formrecord.php';
	$formrecord = new Formrecord($database);

	// Engine Classes 2012
	include_once 'migration/engine/banco.php';
	$banco = new Banco();
	include_once 'migration/engine/usuario.php';
	$usuario = new Usuario($banco);
	include_once 'migration/engine/projeto.php';
	$projeto = new Projeto($banco);
	include_once 'migration/engine/pergunta.php';
	$pergunta = new Pergunta($banco); 
	include_once 'migration/engine/formulario.php'; 
	$formulario = new Formulario($banco);  
	include_once 'migration/engine/forma.php'; 
	$forma = new Forma($banco);
	include_once 'migration/engine/resposta.php';
	$resposta = new Resposta($banco);
	include_once 'migration/engine/arquivo.php';
	$arquivo = new Arquivo($banco);

	// Clear all new database
	if ($_GET['blnClearAll'] == 1) {
		$arrProjects = $project->selectProjects2();
		foreach ($arrProjects as $arrProject) {
			$project->deleteProject($arrProject['idProject']);
		}
	}
	$blnNoRecords = $_GET['blnNoRecords'] ? 1 : 0;
	$arrUsuariosUsers = array();
	$arrProjetos = $projeto->selectProjetos($_GET['idProject']);
	foreach ($arrProjetos as $i0 => $arrProjeto) {
		if (($blnTest) && ($i0 >= $intTestMax)) break;
		echo 'Incio de Cpia do Projeto ' . $arrProjeto['idProjeto'] . ' - ' . $arrProjeto['strNome'] . '<BR>';
		// Project
		$arrUsuariosN4 = $usuario->selectUsuariosPorNivelProjeto($arrProjeto['idProjeto'], 4);
		$idUsuarioDono = $arrUsuariosN4[0]['idUsuario'];
		$arrDadosProjeto = $projeto->selectDadosDeProjeto($arrProjeto['idProjeto']);
		$arrProject = $project->insertProject($arrUsuariosN4[0]['strEmail'], $arrDadosProjeto[0]['strNome'], $arrDadosProjeto[0]['strPasta'], false);
		$project->updateProject($arrProject['idProject'], $arrDadosProjeto[0]['strPasta'], $arrDadosProjeto[0]['strNome'], $arrDadosProjeto[0]['strDescricao'], '', $arrUsuariosN4[0]['dblLatitude'], $arrUsuariosN4[0]['dblLongitude'], '', '', '', $arrDadosProjeto[0]['blnAceitaVisitante'], $arrDadosProjeto[0]['blnHabilitaCadastroPrevio'], $arrDadosProjeto[0]['idEscopoVisualizacao'], $arrDadosProjeto[0]['idEscopoQuestionario']);
		// Copy Logo File
		if (strpos($arrDadosProjeto[0]['strCaminhoLogo'], 'images/') === FALSE) {
			$project->updateFile($arrProject['idProject'], '../' . $arrDadosProjeto[0]['strCaminhoLogo'], 'strLogoFile', true);
		}
		// Copy Background File
		if (strpos($arrDadosProjeto[0]['strCaminhoBackground'], 'images/') === FALSE) {
			$project->updateFile($arrProject['idProject'], '../' . $arrDadosProjeto[0]['strCaminhoBackground'], 'strBackgroundFile', true);
		}
		// Users
		echo 'Usurios<BR>';
		$arrUsuarios = $usuario->selectUsuariosProjeto($arrProjeto['idProjeto']);
		foreach ($arrUsuarios as $i1 => $arrUsuario) {
			// No inserir o dono do projeto porque j foi inserido na criao
			$arrDadosUsuario = $usuario->selectUsuario($arrUsuario['idUsuario'], $arrProjeto['idProjeto']);
			echo 'Usurio ' . ($i1+1) . '/' . count($arrUsuarios) . ' - ' . $arrDadosUsuario[0]['strNome'] . '<BR>';
			// Insert Event
			if ($arrUsuario['idUsuario'] == $idUsuarioDono) {
				$user->updateUser($arrProject['idUser'], '', $arrDadosUsuario[0]['idNivel'], $arrDadosUsuario[0]['blnAtivo'], $arrDadosUsuario[0]['strNome'], $arrDadosUsuario[0]['strEmail'], $arrDadosUsuario[0]['strSenha'], $arrDadosUsuario[0]['dblLatitude'], $arrDadosUsuario[0]['dblLongitude'], '', true);
				$arrUser['idUser'] = $arrProject['idUser'];
			} else {
				$arrUser = $user->insertUser($arrProject['idProject'], $arrDadosUsuario[0]['idNivel'], $arrDadosUsuario[0]['blnAtivo'], $arrDadosUsuario[0]['strNome'], $arrDadosUsuario[0]['strEmail'], $arrDadosUsuario[0]['strSenha'], $arrDadosUsuario[0]['dblLatitude'], $arrDadosUsuario[0]['dblLongitude'], '', 0, true);
			}
			if ($i1 == 0) {
				$database->insertEvent(19, $arrUser['idUser']);
			}
			// Maps idUsuario (old) for idUser (new)
			$arrUsuariosUsers[$arrUsuario['idUsuario']] = $arrUser['idUser'];
			if (!$blnTest) { // If is Test, do not insert user route
				// User Position
				echo 'Posies do Usurio<BR>';
				$arrRotasUsuario = $usuario->selectRotasUsuario($arrUsuario['idUsuario']);
				foreach ($arrRotasUsuario as $i2 => $arrRotaUsuario) {
					if (($blnTest) && ($i2 >= $intTestMax)) break;
					$user->insertUserPosition($arrUser['idUser'], $arrRotaUsuario['dblLatitude'], $arrRotaUsuario['dblLongitude'], $arrRotaUsuario['dtDataHora']);
				}
			}
		}
		// Forms
		$arrFormularios = $formulario->selectFormularioProjeto($arrProjeto['idProjeto']);
		echo 'Formulrios<BR>';
		foreach ($arrFormularios as $i2 => $arrFormulario) {
			if (($blnTest) && ($i2 >= $intTestMax)) break;
			echo 'Formulrio ' . ($i2+1) . '/' . count($arrFormularios) . ' - ' . $arrFormulario['strNome'] . '<BR>';
			// Inserting Marker
			$arrMarker['idMarker'] = $form->strings->idMarkerDefault;
			$strMarkerPath = '/images/formas/' . $arrFormulario['idFigura'] . '.png';
			$strMarkerPathFull = $strViconOldFolder . $strMarkerPath;
			if (file_exists('..' . $strMarkerPath)) {
				$arrMarker = $form->uploadFileMarker($arrProject['idProject'], $strMarkerPathFull, true);
			}
			// Inserting Form
			$arrForm = $form->insertForm($arrProject['idUser'], $arrProject['idProject'], $arrFormulario['strNome'], $arrMarker['idMarker']);
			// Fields & Alternatives
			$arrPerguntas = $formulario->selectPerguntaFormulario($arrFormulario['idFormulario']);
			$arrFormFieldsMap = array();
			$arrAlternativesMap = array();
			foreach ($arrPerguntas as $i3 => $arrPergunta) {
				echo 'Pergunta ' . ($i3+1) . '/' . count($arrPerguntas) . ' - ' . $arrPergunta['strEnunciado'] . '<BR>';
				$arrFormField = $form->insertFormField($arrForm['idForm'], $arrPergunta['idTipoPergunta'], $arrPergunta['strEnunciado'], $arrPergunta['strDicaPergunta'], $arrPergunta['intOrdem']);
				$arrFormFieldsMap[$arrPergunta['idPergunta']] = $arrFormField['idFormField'];
				// Field Alternatives
				$arrAlternativas = $pergunta->selectAlternativaPergunta($arrPergunta['idPergunta']);
				foreach ($arrAlternativas as $arrAlternativa) {
					$arrAlternative = $form->insertFieldAlternative($arrFormField['idFormField'], $arrAlternativa['strEnunciado']);
					$arrAlternativesMap[$arrAlternativa['idAlternativa']] = $arrAlternative['idFormFieldAlternative'];
				}
			}
			// Form Records
			if ((! $blnNoRecords) && ($arrFormulario['blnAtivo'])) {
			echo 'Registros<BR>';
			$arrRespostasFormulario = $resposta->selectRespostasFormulario2($arrFormulario['idFormulario']);
			foreach($arrRespostasFormulario as $i4 => $arrRespostaFormulario) {
				if (($blnTest) && ($i4 >= $intTestMax)) break;
				echo 'Registro ' . ($i4+1) . '/' . count($arrRespostasFormulario) . ' - ' . $arrRespostaFormulario['idRespostaFormulario'] . '<BR>';
				$arrFormaResposta = $forma->selectFormaResposta($arrRespostaFormulario['idRespostaFormulario']);
				$idShapeType = $arrFormaResposta[0]['idTipoForma'];
				$arrVerticesForma = $forma->selectVerticesForma($arrFormaResposta[0]['idForma']);
				$arrCoordinates = array();
				foreach ($arrVerticesForma as $i => $arrVerticeForma) {
					$arrCoordinates[$i]['dblLatitude'] = $arrVerticeForma['dblLatitude'];
					$arrCoordinates[$i]['dblLongitude'] = $arrVerticeForma['dblLongitude'];
				}
				$idDispositivo = 1;
				if ($arrRespostaFormulario['idDispositivo'] == 2) $idDispositivo = 2;
				$idUser = $arrUsuariosUsers[$arrRespostaFormulario['idUsuarioCriador']]; // $arrProject['idUser'];
				$arrFormRecord = $formrecord->insertFormRecord($idUser, $arrForm['idForm'], $idDispositivo, $idShapeType, '', $arrCoordinates, $arrRespostaFormulario['dtCriacao']);
				// Respostas
				$arrRespostasPerguntasRespostaFormulario = $resposta->selectRespostasPerguntasRespostaFormulario($arrRespostaFormulario['idRespostaFormulario']);
				$arrPerguntasFormulario = $formulario->selectPerguntaFormulario($arrFormulario['idFormulario']);
				foreach($arrPerguntasFormulario as $arrPerguntaFormulario) {
					$idFormFieldI = $arrFormFieldsMap[$arrPerguntaFormulario['idPergunta']];
					$strValue = utf8_encode($resposta->returnInfoCampoFormulario($arrRespostasPerguntasRespostaFormulario, $arrPerguntaFormulario['idPergunta'], $arrPerguntaFormulario['idTipoPergunta']));	
					if ($arrPerguntaFormulario['idTipoPergunta'] == 1) {
						$formrecord->insertFormRecordFieldText($arrFormRecord['idFormRecord'], $idFormFieldI, $strValue);
					} else if ($arrPerguntaFormulario['idTipoPergunta'] == 2) {
						$formrecord->insertFormRecordFieldNumeric($arrFormRecord['idFormRecord'], $idFormFieldI, $strValue);
					} else if (($arrPerguntaFormulario['idTipoPergunta'] == 3) || ($arrPerguntaFormulario['idTipoPergunta'] == 4)) {
						$arrIdAlternativas = $resposta->strIdsFormRecordFieldAlternativesPergunta($arrRespostaFormulario['idRespostaFormulario'], $arrPerguntaFormulario['idPergunta']);
						foreach ($arrIdAlternativas as $idAlternativa) {
							$formrecord->insertFormRecordFieldAlternative($arrFormRecord['idFormRecord'], $idFormFieldI, $arrAlternativesMap[$idAlternativa]);
						}	
						//$formrecord->insertFormRecordFieldAlternative($arrFormRecord['idFormRecord'], $idFormFieldI, $strValue);
					} else if ($arrPerguntaFormulario['idTipoPergunta'] == 5) {
						$formrecord->insertFormRecordFieldDate($arrFormRecord['idFormRecord'], $idFormFieldI, $strValue);
					} else if ($arrPerguntaFormulario['idTipoPergunta'] == 6) {
						$formrecord->insertFormRecordFieldTime($arrFormRecord['idFormRecord'], $idFormFieldI, $strValue);
					} else if ($arrPerguntaFormulario['idTipoPergunta'] == 7) {
						$formrecord->insertFormRecordFieldTimeSeries($arrFormRecord['idFormRecord'], $idFormFieldI, $strValue);
					}
				}
				// Files
				echo 'Arquivos<BR>';
				$arrArquivos = $arquivo->selectArquivo($arrRespostaFormulario['idRespostaFormulario']);
				foreach ($arrArquivos as $i5 => $arrArquivo) {
					if (($blnTest) && ($i5 >= $intTestMax)) break;
					echo 'Arquivo '  . ($i5+1) . '/' . count($arrArquivos) . ' - ' . $arrArquivo['strNomeOriginal'] . '<BR>';
					$strOriginalFileFullPath = $strViconOldFolder . '/projetos/' . $arrDadosProjeto[0]['strPasta'] . '/arquivo/' . $arrArquivo['strCaminhoArquivo'];
					$arrArquivo['strLegenda'] = str_replace('ladec/agendacidada/arquivos/', '', $arrArquivo['strLegenda']);
					$arrFormRecordFile = $formrecord->insertFormRecordFile($arrProject['idProject'], $arrFormRecord['idFormRecord'], $strOriginalFileFullPath, $arrArquivo['strNomeOriginal'] . '.' . strtolower($arrArquivo['strExtensaoOriginal']), $arrArquivo['strLegenda'], $arrArquivo['intPosicaoExibicao']);
				}
			}
		     }
		}
	}
	
?>