<?	
	$strExt = '';
	if (isset($_FILES["files"])) {
		set_time_limit(150); 
		$arrFiles = $_FILES["files"];
		$strBaseFileName = $strings->generateRandomString(5);
		$blnIsShapeFile = false;
		foreach ($arrFiles['name'] as $i => $strFile) {
			$strExt = explode(".", $strFile);
			$strExt = strtolower(array_pop($strExt));
			if ($strExt == 'shp') {
				$blnIsShapeFile = true;
				$strShpFileName = $strFile;
			}
			$strFileName = $strings->strSiteTmpFileFolder . '/' . $strBaseFileName . '.' . $strExt;
			move_uploaded_file($arrFiles["tmp_name"][$i], $strFileName);
		}
		$strFileName = $blnIsShapeFile ? $strings->strSiteTmpFileFolder . '/' . $strBaseFileName . '.shp' : $strFileName;
		$strExt = $blnIsShapeFile ? 'shp' : $strExt;
		// Call function to fix KML File and set one tag per line
		if ($strExt == 'kml') {
			require_once 'engine/kml.php';
			$kml = new Kml();
			$arrKML = $kml->load($strFileName, false, 10);
			$intNObjects = $arrKML['intNObjects'];
			$strFileInfo = basename($_FILES["files"]['name'][0]) . '  <img src="' . $strings->strImgFilePathByidShapeType(1) . '" style="height:20px;"> ' . $arrKML['intNPoints'] . '  <img src="' . $strings->strImgFilePathByidShapeType(2) . '" style="height:20px;"> ' . $arrKML['intNLines'] . '  <img src="' . $strings->strImgFilePathByidShapeType(3) . '" style="height:20px;"> ' . $arrKML['intNPolygons'] . ' = ' . ($intNObjects) . ' ' . strtolower($_SESSION['strGlobalRecords']);
		} else if ($strExt == 'csv') {
			// Open CSV file, get header to fill combo
			if($fh = fopen($strFileName, 'r')){
				$strContent = fread($fh, filesize($strFileName));
				fclose($fh);
			}
			$strLines = explode(chr(13), $strContent);
			$arrCols = explode(';', $strLines[0]);
			$intNCols = count($arrCols);
			$intNValidLines = 0;
			$strLineJustSemicolon = '';
			for ($i=0;$i<$intNCols-1;$i++) $strLineJustSemicolon .= ';';
			for ($i=1;$i<count($strLines);$i++) {
				if (strpos(' ' . $strLines[$i],$strLineJustSemicolon) > 0) continue;
				if ($strLines[$i] == '') continue;
				if (strpos(' ' . $strLines[$i],';') == 0) continue;
				$intNValidLines++;
			}
			$intNObjects = $intNValidLines;
			$strFileInfo = basename($_FILES["files"]['name'][0]) . ' - ' . $intNObjects . ' ' . strtolower($_SESSION['strGlobalRecords']);
		} else if (($strExt == 'xls') || ($strExt == 'xlsx')) {
			require_once ('js/excel/Classes/PHPExcel/IOFactory.php');
			$XLS = PHPExcel_IOFactory::load($strFileName);
			// Read Plan 1
			$XLS->setActiveSheetIndex(0);
			$Plan = $XLS->getActiveSheet();
			$intNObjects = 1;
			while($Plan->getCellByColumnAndRow(0, $intNObjects)->getValue() != '') $intNObjects++;
			$intNObjects = $intNObjects - 2; // All but header and last (empty) lines
			// Cols
			$arrCols = array();
			$intCol = 0;
			while($Plan->getCellByColumnAndRow($intCol, 1)->getValue() != '') {
				$arrCols[] = utf8_decode($Plan->getCellByColumnAndRow($intCol, 1)->getValue());
				$intCol++;
			}
			$strFileInfo = basename($_FILES["files"]['name'][0]) . ' - ' . $intNObjects . ' ' . strtolower($_SESSION['strGlobalRecords']);
		} else if ($strExt == 'shp') {
			require 'engine/shapefile/reader/shpParser.php';
			$shp = new shpParser();
			$shp->load($strings->strSiteTmpFileFolder . '/' . $strBaseFileName . '.shp');
			$data = $shp->getShapeData();
			$intNObjects = max($shp->intTotalParts, count($data));
			$shpBB = $shp->headerInfo['boundingBox'];
			// Test if UTM -> Convert to Geographic before continue
			$blnUTM = false;
			$strCoord = explode('.', $shpBB['ymin']);
			$strCoord = $strCoord[0];
			if (strlen($strCoord) >= 4) { $blnUTM = true; }			
			$strFileInfo = $strShpFileName . ' - ' . $intNObjects . ' ' . strtolower($_SESSION['strGlobalRecords']);
		}
	} // End of File Load
?>
<div class="sessionTitle">
	<i class="<? echo $importer->strDefaultIcon; ?>"></i>
	<? echo $_SESSION['strHomeToolsDataImporter']; ?>
	<span class="hidden-phone">
    <? if (($strExt == 'csv') || ($strExt == 'xls') || ($strExt == 'xlsx') || ($strExt == 'kml') || ($strExt == 'shp')) { echo ' - ' . $strFileInfo; } ?>
    </span>
    <input type="file" name="files[]" id="files[]" onChange="blnIsValidFileExt(this.value);" style="display:none" multiple>
	<? if (($strExt == 'csv') || ($strExt == 'xls') || ($strExt == 'xlsx') || ($strExt == 'kml') || ($strExt == 'shp')) { ?>
	<a class="btn btn-success" name="btnImport" id="btnImport" data-loading-text="<? echo $_SESSION['strGlobalProcessing']; ?>" style="float:right;position:relative;top:-4px;margin-left:5px;" onClick="importExecute('<? echo $strExt; ?>');"/><i class="icon-play icon-white"></i><span class="hidden-phone"> <? echo $_SESSION['strToolImporterImport']; ?></span></a>
    <? } ?>
	<a class="btn btn-info" name="btnFileLoad" id="btnFileLoad" data-rel="tooltip" title="<? echo $_SESSION['strToolImporterFilesFormatSHPInfo']; ?>" data-loading-text="<? echo $_SESSION['strGlobalWait']; ?>..."  onClick="document.getElementById('files[]').click();" style="float:right;position:relative;top:-4px;"><i class="icon-folder-open icon-white"></i> <? echo $_SESSION['strGlobalLoad']; ?></a>
</div>

<div id="divProgress" class="progress progress-striped progress-success active" style="color:#000000;height:27px;font-weight:bold;display:none">
    <div id="divProgressLabel" style="position:absolute;text-align:center;width:100%;padding-top: 4px;"></div>
    <div id="divProgressBar" class="bar" style="width:0%;line-height:27px;height:27px;color:#000000;text-indent:5px;text-align:center;"></div>
</div>

<? if (($strExt == 'csv') || ($strExt == 'xls') || ($strExt == 'xlsx') || ($strExt == 'kml') || ($strExt == 'shp')) { ?>
   <select name="idForm" id="idForm" style="width:100%" onChange="formChange();">
        <option strMarkerFullPath="<? echo $strDefaultMarkerFilePath; ?>" value=""><? echo $_SESSION['strToolImporterErrorSelectForm']; ?></option>
        <?
        if ($arrUser['idUserLevel'] >= 4) {
            echo '<option strMarkerFullPath="' . $strDefaultMarkerFilePath . '" value="N">' . $_SESSION['strToolImporterFormNew'] . '</option>';
        }
        $arrForms = $form->selectForms($arrProject['idProject']);
        foreach($arrForms as $arrForm) {
            echo '<option strMarkerFullPath="' .  $arrForm['strMarkerFullPath']. '" strName="' .  $arrForm['strName']. '" value="' .  $arrForm['idForm']. '">' . $arrForm['strName'] . '</option>';
        }
        ?>
    </select>

	<? if ($strExt == 'shp') { ?>
    <select name="idDatumIn" id="idDatumIn" style="width:100%;">
        <option value=""><? echo $_SESSION['strToolConversorDatumOrigin'] . ' (' . $_SESSION['strGlobalOptional'] . ')'; ?></option>
        <?
        $arrDatums = $database->selectDatum();
        foreach ($arrDatums as $arrDatum) {
            echo '<option value="' . $arrDatum['idDatum'] . '" ' . ($_COOKIE['idDatumIn'] == $arrDatum['idDatum'] ? ' selected' : '') . '>' . $arrDatum['strName'] . '</option>';
        }
        ?>
    </select>
    <? } ?>
    
    <?
	if ($strExt == 'kml') {
		echo $arrKML['strTable'];
	} else if (($strExt == 'shp') && ($blnUTM)) {
		echo '
		<label style="font-weight:bold">' . $_SESSION['strToolImporterUTMZone'] . ':</label>
		<select name="intUTMZone" id="intUTMZone" style="width:50px;">
		';
		for ($i=1;$i<=60;$i++) {
			echo '<option value="' . $i . '" ' . ($_COOKIE['intUTMZone'] == $i ? ' selected' : '') . '>' . $i . '</option>';
		}
		echo '
		</select>
		<select name="chrUTMHemisphere" id="chrUTMHemisphere" style="width:70px">
            <option value="K" ' . ($_COOKIE['chrUTMHemisphere'] == "K" ? ' selected' : '') . '>Sul</option>
            <option value="N" ' . ($_COOKIE['chrUTMHemisphere'] == "N" ? ' selected' : '') . '>Norte</option>
	    </select>
		';
	} else if (($strExt == 'csv') || ($strExt == 'xls') || ($strExt == 'xlsx')) {
		echo '<select name="idLatitude" id="idLatitude" style="width:100%">
			<option value="">' . $_SESSION['strToolImporterSelectLatitude'] . '</option>';
		$i=1;
		foreach($arrCols as $strCol) {
			echo '<option value="' . $i . '" ' . (strpos(strtoupper(' ' . $strCol),'LAT') !== FALSE ? 'selected' : '') . '>' . $strCol . ' </option>';
			$i++;
		}			
		echo '</select>';
		
		echo '<select name="idLongitude" id="idLongitude" style="width:100%">
			<option value="">' . $_SESSION['strToolImporterSelectLongitude'] . '</option>';
		$i=1;
		foreach($arrCols as $strCol) {
			echo '<option value="' . $i . '" ' . (((strpos(strtoupper(' ' . $strCol),'LONG') !== FALSE) || (strpos(strtoupper(' ' . $strCol),'LNG') !== FALSE))? 'selected' : '') . '>' . $strCol . ' </option>';
			$i++;
		}			
		echo '</select>';
	}
	?> 
<? } ?>
<div class="alert alert-primary" style="text-align:center;font-weight:bold">
	<p><? echo $_SESSION['strToolImporterFilesFormatInfo']; ?></p>
	<p><? 
		//$intMaxploadFileSizeMB = $strings->intMaxploadFileSizeMB;
		$intMaxploadFileSizeMB = trim(str_replace('M', '', ini_get('upload_max_filesize')));
		echo $_SESSION['strToolImporterFilesUploadMaxSize'] . ': ' . $intMaxploadFileSizeMB . ' MB'; 
	?></p>
	<a href="help/?s=toolImporter" target="_blank" style="color:#000000;text-decoration:underline"><? echo $_SESSION['strToolImporterHelp']; ?></a>
</div>

<script>
	function blnIsValidFileExt(val){
		if(!/[^/].(?:xls|xlsx|csv|kml|shp|shx|dbf)/i.test(val)){
			showInfoAlert('<? echo $_SESSION['strErrorInvalidFormat']; ?> SHP + DBF, XLS, XLSX, CSV, KML');
			return;
		} 
		document.getElementById('frmForm').submit();
	}
	
	function importExecute(strExt) { // kml or csv
		// Check if user selected any form to import. Otherwise don't continue
		if (document.getElementById('idForm').value == "") {
			showInfoAlert('<? echo $_SESSION['strToolImporterErrorSelectForm']; ?>');
			document.getElementById('idForm').focus();
			return false;
		}
		
		if (strExt == 'csv')  {	
			if (document.getElementById('idLatitude').value == "") {
				showInfoAlert('<? echo $_SESSION['strToolImporterErrorSelectLatitudeField']; ?>');
				return false;
				document.getElementById('idLatitude').focus();
			} else if (document.getElementById('idLongitude').value == "") {
				showInfoAlert('<? echo $_SESSION['strToolImporterErrorSelectLongitudeField']; ?>');
				document.getElementById('idLongitude').focus();
				return false;
			}
		}
				
		// http://stratosprovatopoulos.com/web-development/php/ajax-progress-php-script-without-polling/
		// http://www.dave-bond.com/blog/2010/01/JQuery-ajax-progress-HMTL5/
		if (! window.XMLHttpRequest){ alert("Your browser does not support the native XMLHttpRequest object."); return; }
		try{
			var xhr = new XMLHttpRequest();  
			xhr.previous_text = '';							 
			xhr.onerror = function() { alert("[XHR] Fatal Error."); };
			xhr.onreadystatechange = function() {
				try{
					$('#btnImport').button('loading');
					$('#btnFileLoad').button('loading');
					importUpdateProgressBar(0);
					if (xhr.readyState == 4) {
						$('#btnImport').button('reset');
						$('#btnFileLoad').button('reset');
						importUpdateProgressBar();
						if (xhr.responseText) {
							if (xhr.responseText.indexOf('OK') > 0) {
								showInfoAlert("<? echo $intNObjects . ' ' . $_SESSION['strToolImporterInfoSuccess']; ?> " + document.getElementById('idForm').options[document.getElementById('idForm').selectedIndex].text);
							} else {
								showInfoAlert("<? echo $_SESSION['strToolImporterLessFieldsMessage']; ?>");
							}
						}
					} else if (xhr.readyState > 2) {
						var arrStatus = xhr.responseText.split(",");
						//var strResponse = xhr.responseText.substring(xhr.previous_text.length);
						//var arrResult = JSON.parse(strResponse);
						//importUpdateProgressBar(arrResult.idStatus);
						//console.log(arrStatus[arrStatus.length-1]);
						importUpdateProgressBar(arrStatus[arrStatus.length-1]);
						//xhr.previous_text = xhr.responseText;
					}
				} catch (e){}
			};
			xhr.open("GET", "ajax.php?chrAction=II" +
					"&idProject=<? echo $arrProject['idProject']; ?>" +
					"&idUser=<? echo $arrUser['idUser']; ?>" +
					"&idForm=" + document.getElementById('idForm').value + 
					"&strFormName=" + document.getElementById('idForm').options[document.getElementById('idForm').selectedIndex].text + 
					"&strFileName=<? echo $strFileName; ?>" + 
					"&intUTMZone=" + (document.getElementById('intUTMZone') ? document.getElementById('intUTMZone').value : '') +
					"&chrUTMHemisphere=" + (document.getElementById('chrUTMHemisphere') ? document.getElementById('chrUTMHemisphere').value : '') + 
					"&idLatitude=" + (document.getElementById("idLatitude") ? document.getElementById("idLatitude").value : "") +
					"&idLongitude=" + (document.getElementById("idLongitude") ? document.getElementById("idLongitude").value : "") +
					"&idDatumIn=" + (document.getElementById("idDatumIn") ? document.getElementById("idDatumIn").value : "")
					, true);
			xhr.send();      
		} catch (e){ alert("AJAX Not Supported"); }
	}
	
	function importUpdateProgressBar(intCurrent) {	
		var progress = document.getElementById('divProgress');
		if (! intCurrent) {
			progress.style.display = 'none';
			return;
		}
		var intTotal = <? echo $intNObjects ?  $intNObjects  : "0" ; ?>;		
		if ((intCurrent >= 0) && (intCurrent <= intTotal)) {
			progress.style.display = 'block';
			var progressBar = document.getElementById('divProgressBar');
			var progressLabel = document.getElementById('divProgressLabel');
			var intWidth = intTotal > 0 ? (intCurrent/intTotal*100).toFixed(2) : 0;
			progressBar.style.width = intWidth + '%';
			progressLabel.innerHTML = numberWithThousands(intCurrent) + '/' + numberWithThousands(intTotal) + ' (' + intWidth + '%)';
		}
	}
	
	function formChange() {
		var combo = document.getElementById('idForm');
		if (combo.value == 'N') {
        	var reply = prompt('<? echo $_SESSION['stradmManageFormsInsertPrompt']; ?>', '');
			if (! reply) return;
			combo.options[combo.options.length] = new Option(reply, 'N');
			combo.options[combo.options.length-1].selected = true;
		}
	}
</script>