<?
	session_start();
	// Initializing Engine Classes
	include_once '../engine/strings.php';
	$strings = new Strings();
	include_once '../engine/database.php';
	$database = new Database('../');
	include_once '../engine/project.php';
	$project = new Project($database);
	include_once '../engine/user.php';
	$user = new user($database);
	include_once '../engine/form.php';
	$form = new Form($database);
	include_once '../engine/formrecord.php';
	$formrecord = new Formrecord($database);
	include_once '../engine/support.php';
	$support = new Support($database);
	include_once '../engine/importer.php';
	$importer = new Importer($database);
	include_once '../engine/censo.php';
	$censo = new Censo();
	
	if ($_GET['idProject']) {
		header("Location: ../index.php?idProject=" . $_GET['idProject']); exit;
	}
	// Loading strings according to selected language
	if ($_GET['language']) {
		$_SESSION['strSiteLanguage'] = $_GET['language'];
	} else if (! $_SESSION['strSiteLanguage']) {
		$_SESSION['strSiteLanguage'] = $strings->strSiteDefaultLanguage;
	}
	$strings->loadLanguage($_SESSION['strSiteLanguage']);

	if ((! $_GET['s']) || (! file_exists($_GET['s'] . '.php'))) {
		$_GET['s'] = $strings->strSiteDefaultHomePage;
		//header("Location:" . $strings->strSiteDefaultHomePage); exit;
	}
?>
<!DOCTYPE html>
<html lang="pt-BR">
<head>
    <title><? echo $strings->strSiteName; ?></title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="">
    <meta name="author" content="<? echo $strings->strSiteAuthorName; ?>">
    <meta name="application-name" content="<? echo $strings->strSiteName; ?>"/>
    <meta name="msapplication-TileColor" content="<? echo $strings->strSiteBaseColor; ?>"/>
    <meta name="msapplication-TileImage" content="<? echo $strings->strSiteURL . '/' . $strings->strSiteLogoPath; ?>"/>
    <meta property="og:locale" content="<? echo $_SESSION['strSiteLanguage']; ?>" />
    <meta property="og:title" content="<? echo $strings->strSiteName; ?>"/>
    <meta property="og:type" content="website"/>
    <meta property="og:url" content="<? echo $strings->strSiteURL; ?>"/>
    <meta property="og:image" content="<? echo $strings->strSiteURL . '/' . $strings->strSiteLogoPath; ?>"/>
    <meta property="og:site_name" content="<? echo $strings->strSiteName; ?>"/>
    <meta property="og:description" content="<? echo $_SESSION['strSiteDescription']; ?>"/>
    <meta name="description" content="<? echo $_SESSION['strSiteDescription']; ?>"/>
    <meta name="keywords" content="<? echo $_SESSION['strSiteKeywords']; ?>"/>
    <!-- Le styles -->
    <link href="../css/bootstrap.css" rel="stylesheet">
    <!-- CSS Styles -->
	<!-- Config Selected Theme -->
	<link id="bs-css" href="../css/bootstrap-united.css" rel="stylesheet">
	<link href="../css/bootstrap-responsive.css" rel="stylesheet">
	<!-- Main Style -->
	<link href="../css/main.css" rel="stylesheet">
	<!-- Charisma -->
	<link href="../css/charisma.css" rel="stylesheet">
	<!-- Custom Fonts -->
	<link href="../fonts/fonts.css" rel="stylesheet">
    <!-- Fav and touch icons -->
    <link rel="shortcut icon" href="../img/logofav.png">
	<!-- javascript Libs-->
    <script src="../js/jquery-1.11.1.js"></script>
	<script src="../js/jquery-ui.js"></script>
    <script src="../js/bootstrap-modal.js"></script>
    <script src="../js/bootstrap-dropdown.js"></script>
    <script src="../js/bootstrap-tooltip.js"></script>
	<script src="../js/bootstrap-button.js"></script>
    <!-- Autocomplete -->
    <script type="text/javascript" src="../js/autocomplete/jquery.mockjax.js"></script>
    <script type="text/javascript" src="../js/autocomplete/jquery.autocomplete.js"></script>
	<link rel="stylesheet" type="text/css" href="../js/autocomplete/autocomplete.css" media="screen" />
	<!-- Navbar Menu (expand & contract) -->
	<script src="../js/bootstrap-collapse.js"></script>
	<!-- Backstretch -->
	<script src="../js/jquery.backstretch.js"></script>
    <!-- Chosen - Select Autocomplete -->
    <link rel="stylesheet" href="../js/chosen/chosen.css">
	<script src="../js/chosen/chosen.jquery.js" type="text/javascript"></script>
    <!-- Fancybox -->
	<link rel="stylesheet" type="text/css" href="../js/fancybox/jquery.fancybox-1.3.4.css" media="screen" />
	<script type="text/javascript" src="../js/fancybox/jquery.fancybox-1.3.4.js"></script>
	<!-- Google Maps -->
	<script src="https://maps.googleapis.com/maps/api/js?v=3.exp&sensor=false&libraries=places,geometry"></script>
	<!-- Google Search API -->
	<script src="https://www.google.com/jsapi"></script>
	<script src="../js/main.js"></script>
	<!-- Google Analytics -->
	<script>
	  (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
	  (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
	  m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
	  })(window,document,'script','//www.google-analytics.com/analytics.js','ga');
	  ga('create', 'UA-24437288-1', 'auto');
	  ga('send', 'pageview');
	</script>
	<style>.dropdown-backdrop {position: static;}</style>
</head>
<body>
<form action="<? echo $_SERVER["PHP_SELF"] . '?' . $_SERVER["QUERY_STRING"]; ?>" method="post" name="frmForm" id="frmForm" enctype="multipart/form-data">
<span id="alertInfo" class="alert alert-primary" style="display:none;z-index:9999;position:absolute;left:35%;text-align:center;width:300px;"><i class="icon-info-sign"></i> <strong><span id="alertInfoMessage"></span></strong></span>
<span id="alertSuccess" class="alert alert-success" style="display:none;z-index:9999;position:absolute;left:46%;color:#008400;text-align:center;width:80px;border:solid 1px #008040"><i class="icon-ok-circle"></i> <strong><? echo $_SESSION['strGlobalSaved']; ?></strong></span>
<span id="top"></span>
<div class="container">
	<div class="masthead">
        <div class="navbar">
          <div class="navbar-inner" style="padding-left:2px;padding-right:0px;">
            <button type="button" class="btn btn-navbar" data-toggle="collapse" data-target=".nav-collapse">
              <span class="icon-bar"></span>
              <span class="icon-bar"></span>
              <span class="icon-bar"></span>
            </button>
			<!-- Start Language Menu -->
            <input type="hidden" name="strSiteLanguage" id="strSiteLanguage">
            <div class="btn-group pull-right" style="top:4px;position:relative;padding-left:0px;">
                <a class="btn dropdown-toggle" data-toggle="dropdown" href="#">
                	<img src="../img/language/<? echo $_SESSION['Indice']; ?>.png" align="absmiddle" style="width:24px;height:24px;">
                    <span class="caret"></span>
                </a>
                <ul class="dropdown-menu" style="padding:4px;width:210px;">
                <?
                $arrLanguages = $strings->loadLanguagesList();
                sort($arrLanguages);
                foreach($arrLanguages as $item) {
                    $arrTupla = explode(':', $item);
                    echo '<li><a href="./language=' . $arrTupla[1] . '" style="font-size:12px;"><img src="../img/language/' . strtolower($arrTupla[1]) . '.png" align="absmiddle" style="width:24px;height:24px;"> <b>' . $arrTupla[0] . '</b></a></li>';
                }
                ?>
                </ul>
            </div>
			<!-- End Language Menu -->

			<!-- Button Join -->
			<? if ($database->blnSiteAllowProjectCreation == 1) { ?>
           	<a href="join" class="btn btn-success pull-right" style="padding:8px;position:relative;top:4px;" data-rel="tooltip" title="<? echo $_SESSION["strFeaturesJoinNowButton"]; ?>"><i class="icon-edit icon-white"></i><span class="hidden-phone"> <? echo $_SESSION["strFeaturesJoinNowButton"]; ?></span></a>
            <? } ?>

            <!-- Search Site -->
			<input type="text" id="strSearchProjects" name="strSearchProjects" style="width:19%;position:relative;top:11px;background-position:right;background-repeat:no-repeat;margin-right:5px;" class="pull-right" placeholder="<? echo $_SESSION["strMenuSearchProjects"]; ?>..." value="<? echo $_GET["q"]; ?>">

            <!-- Logo -->
            <div style="float:left;margin-right:5px;;height:50px;overflow-y:hidden;cursor:pointer">
            	<a href="home" data-rel="tooltip" title="<? echo $_SESSION["strMenuHome"]; ?>" class="navbar-link">
                <table width="100%">
                <tr style="height:50px;overflow-y:hidden;">
                    <td style="vertical-align:top;width:50px;"><img id="imgLogo" src="../<? echo $strings->strSiteLogoPath; ?>" style="height:46px;"></td>
                    <td style="vertical-align:middle;font-family:'Bauhaus93';text-shadow:1px 1px #000000;font-size:25px;line-height:25px;word-wrap:break-word;width:70px;letter-spacing: 2px;"><? echo $strings->strSiteName; ?></td>
                </tr>
                </table>
                </a>
			</div>

            <!-- Tab menu -->
            <div class="nav-collapse collapse">
                <ul class="nav">
                    <li <? echo $_GET['s'] == 'home'	? ' class="active"' : ''; ?>><a href="home"><i class="icon-home icon-white"></i> <? echo $_SESSION["strHeaderMenuHome"]; ?></a></li>
                    <li <? echo $_GET['s'] == 'projects'? ' class="active"' : ''; ?>><a href="projects"><i class="<? echo $project->strDefaultIcon; ?> icon-white"></i> <? echo $_SESSION["strHeaderMenuProjects"]; ?></a></li>
                    <li <? echo $_GET['s'] == 'features'? ' class="active"' : ''; ?>><a href="features"><i class="icon-thumbs-up icon-white"></i> <? echo $_SESSION["strHeaderMenuFeatures"]; ?></a></li>
                    <li <? echo $_GET['s'] == 'download'? ' class="active"' : ''; ?>><a href="download"><i class="icon-download icon-white"></i> <? echo $_SESSION["strHeaderMenuDownload"]; ?></a></li>
                    <li class="<? echo $_GET['s'] ==  'tools' ? ' active' : ''; ?>">
                        <a href="#" class="dropdown-toggle" data-toggle="dropdown"><i class="icon-wrench icon-white"></i> <? echo $_SESSION["strHeaderMenuTools"]; ?>  <span class="caret"></span></a>
                        <ul class="dropdown-menu" style="left:360px">
                            <li><a href="tool-geocoder"><? echo $_SESSION['strHomeToolsGeocoder']; ?></a></li>
                            <li><a href="tool-conversor-coordinates"><? echo $_SESSION['strHomeToolsConversor']; ?></a></li>
                            <li><a href="tool-conversor-xls-to-dbf"><? echo $_SESSION['strHeaderMenuToolsXLS2DBF']; ?></a></li>
                            <li><a href="tool-conversor-shp-kml-to-rs2"><? echo $_SESSION['strHeaderMenuToolsVEC2RS2']; ?></a></li>
                            <li><a href="tool-censo"><? echo $_SESSION['strHeaderMenuToolsCenso']; ?></a></li>
                        </ul>
                    </li>
                	<li <? echo ($_GET['s'] == 'contact'? ' class="active"' : ''); ?>><a href="contact"><i class="icon-comment icon-white"></i> <? echo $_SESSION["strMenuContact"]; ?></a></li>
                </ul>
            </div>
          </div>
        </div><!-- /.navbar -->
      </div><!-- /.masterhead -->

	<script>
        function projectSearch(){
            window.location = "projects?q=" + document.getElementById('strSearchProjects').value;
        }
    
        function searchInitialize(){
            var objSearch = document.getElementById('strSearchProjects');
            $('#strSearchProjects').autocomplete({
                serviceUrl: '../ajax.php?chrAction=SIPS',
                minChars:3,
                onSearchStart: function (query) {
                    objSearch.style.backgroundImage="url(../img/loading1.gif)";
                },
                onSearchComplete: function (query, suggestions) {
                    objSearch.style.backgroundImage = "";
                },
                onSelect: function(suggestion) {
                    objSearch.value = suggestion.query;
                    window.open ('../' + suggestion.strAlias, '_blank');
                }
            });
        }
    
        $.backstretch(["../<? echo $strings->strSiteDefaultBackgroundFile; ?>"], {duration: 3000, fade: 2000});
    
        $(document).ready( function () {
            searchInitialize();
        
            //prevent # links from moving to top
            $('a[href="#"][data-top!=true]').click(function(e){
                e.preventDefault();
            });
    
            // Initializing Tooltip
            $('[rel="tooltip"],[data-rel="tooltip"]').tooltip({"placement":"bottom",delay: { show: 400, hide: 200 }});
    
            // Initializing Fancybox
            $("a[rel=photoGroup]").fancybox({
                'transitionIn'		: 'none',
                'transitionOut'		: 'none',
                'titlePosition' 	: 'over',
                'titleFormat'       : function(title, currentArray, currentIndex, currentOpts) {
                    return '<span id="fancybox-title-over">' +  (currentIndex + 1) + '/' + currentArray.length + ' - ' + title + '</span>';
                }
            });
    
            // Smooth Scroll
            $(".scroll").click(function(event){
                event.preventDefault();
                $('html,body').animate({scrollTop:$(this.hash).offset().top}, 800);
           });
        });
    </script>
    <div class="row translucent70 shine rounded" style="padding-bottom:10px;text-align:justify;color:#000000;">
	<?
		@include($_GET['s'] . '.php');
    ?>
    </div>

	<div class="footer" style="position:fixed; left:0px; bottom: 10px; height:17px; width:100%;text-align:right;z-index:-1;">
        <span style="float:left">
        	<?
				echo
					($strings->strSiteSkypeID ? $strings->strSkypeUserStatus($strings->strSkypeID, 24, false) : '') .
					($strings->strSiteFacebookID ? '<a href="http://www.facebook.com/' . $strings->strSiteFacebookID . '" target="_blank" title="' . $_SESSION['strFooterSocialNetworksVisitTip'] . ' http://www.facebook.com/' . $strings->strSiteFacebookID . '"><img src="../img/socialnetworks/facebook.png" align="absmiddle" style="width:24px;height:24px;"> </a>': '') .
					($strings->strSiteTwitterID ? '<a href="http://www.twitter.com/' . $strings->strSiteTwitterID . '" target="_blank" title="' . $_SESSION['strFooterSocialNetworksVisitTip'] . ' http://www.twitter.com/' . $strings->strSiteTwitterID . '"><img src="../img/socialnetworks/twitter.png" align="absmiddle" style="width:24px;height:24px;"> </a>': '') .
					($strings->strSiteYoutubeID ? '<a href="http://www.youtube.com/user/' . $strings->strSiteYoutubeID . '" target="_blank" title="' . $_SESSION['strFooterSocialNetworksVisitTip'] . ' http://www.youtube.com/user/' . $strings->strSiteYoutubeID . '"><img src="../img/socialnetworks/youtube.png" align="absmiddle" style="width:24px;height:24px;"> </a>': '') .
					($strings->strSiteGooglePlusID ? '<a href="https://plus.google.com/+' . $strings->strSiteGooglePlusID . '" target="_blank" title="' . $_SESSION['strFooterSocialNetworksVisitTip'] . ' https://plus.google.com/+' . $strings->strSiteGooglePlusID . '"><img src="../img/socialnetworks/googleplus.png" align="absmiddle" style="width:24px;height:24px;"> </a>': '')
				;
			?>
        </span>
        <p style="margin-right:20px;color:#000000;font-size:12px;font-weight:bold">
            &copy;  2007  
            <a href="../help" target="_blank"><? echo $_SESSION["strFooterHelp"]; ?></a>  
			<a href="../help/api" target="_blank">API</a>  
            <a href="home" target="_self"><? echo $strings->strSiteURL; ?></a>
		</p>
    </div>
</div>
</form>
</body>
</html>